public class NameList {
    String name = "";
    public int count = 0;

    public void addName(String str, java.util.List list)
    {
        // Only one thread is permitted
        // to change name at a time.
        synchronized(this)
        {
            name = str;
            count++;  // how many threads change the name.
        }

        // All other threads are permitted
        // to add name into list.
        list.add(str);
    }

    public int getCount(){
        return count;
    }
}
